unit Comm;

interface

uses Objects;
type
  PComm = ^TComm;
  TComm = Object(TObject)
      UsedPort: Word;
    constructor Init;
    destructor Done; virtual;
    procedure Setup(Baud: LONGINT; DataBits: BYTE; Parity: CHAR; Stop: BYTE);  virtual;
    procedure Dtr(State: BOOLEAN); virtual;
    procedure Flow(State: Byte); virtual;
    function  Carrier: boolean; virtual;
    procedure ClearOut; virtual;
    procedure ClearIn;  virtual;
    procedure FlushOut; virtual;
    function  Received: BOOLEAN; virtual;
    function  Receive: CHAR; virtual;
    procedure Send(Character: CHAR); virtual;
    function  Ring: BOOLEAN; virtual;
    procedure SendBreak;  virtual;
    procedure SetBaud(Baud: LongInt);  virtual;
    function  GetBaud: LongInt;  virtual;
    function  TxReady : boolean; virtual;

    function  WaitReceived: boolean;
    function  WaitCarrier: boolean;
    function  WaitTxReady: boolean;
    procedure WriteString(S : string);
    procedure WriteStringLn(S : string);
    procedure WriteBuffer(var Buf; Size: Word);
  end;

type
 TAbortFunc = function : boolean;

procedure SetAbortFunc(AbortFunc: TAbortFunc);

implementation

uses Timer, Drivers, BaseApp;

function DefUserAbort: boolean; far;
begin
 DefUserAbort:=False;
 IdleProcess;
end;

const
 CurAbortFunc: TAbortFunc = DefUserAbort;

procedure SetAbortFunc(AbortFunc: TAbortFunc);
begin
 CurAbortFunc:=AbortFunc;
end;

constructor TComm.Init;
begin
 inherited Init;
 UsedPort:=0;
end;

procedure TComm.Setup(Baud: LONGINT; DataBits: BYTE; Parity: CHAR; Stop: BYTE);
begin
end;

destructor TComm.Done;
begin
 inherited Done;
end;

procedure TComm.Dtr(State: boolean);
begin

end;

procedure TComm.ClearOut;
begin

end;

procedure TComm.ClearIn;
begin

end;

procedure TComm.FlushOut;
begin

end;

function TComm.Received: BOOLEAN;
begin
end;

function TComm.Receive: CHAR;
begin
end;

procedure TComm.Send(Character: CHAR);
begin
end;

function TComm.Ring: BOOLEAN;
begin
end;

procedure TComm.SendBreak;
begin
end;

procedure TComm.Flow(State: Byte);
begin

end;

function TComm.TxReady : boolean;
begin
 CurAbortFunc;
end;

function TComm.Carrier: boolean;
begin
 CurAbortFunc;
end;

procedure TComm.SetBaud(Baud: LongInt);
begin

end;

function  TComm.GetBaud: LongInt;
begin

end;

procedure TComm.WriteBuffer(var Buf; Size: Word);
var
 I: LongInt;
 Ch: char;
begin
  I := 0;
  repeat
   if Carrier then
    begin
     Ch:=Char(Mem[Seg(Buf): Ofs(Buf)+i]);
     if WaitTxReady then Send(Ch);
     Inc(I);
    end;
  until (not Carrier) or (I >= Size);
end;

procedure TComm.WriteString(S : String);
var
  I : Byte;
begin
 for I := 1 to Length(S) do
  begin
   Send(S[I]);
  { Delay(100);}
  end;
end;

procedure TComm.WriteStringLn(S : String);
begin
  WriteString(S+#13);
  {Delay(100);}
end;

function TComm.WaitCarrier: boolean;
var
 C: boolean;
 T : TTimer;
begin
 T.Init(2);
 C:=Carrier;
 if not C then repeat C:=Carrier; until (C) or (T.Timeout) or CurAbortFunc;
 WaitCarrier:=C;
 T.Done;
end;

function  TComm.WaitTxReady: boolean;
var
 C: boolean;
 T : TTimer;
begin
 T.Init(2);
 C:=TxReady;
 if not C then repeat C:=TxReady; until (C) or (T.Timeout) or CurAbortFunc;
 WaitTxReady:=C;
 T.Done;
end;

function TComm.WaitReceived: boolean;
var
 T: TTimer;
begin
 T.Init(10);
 repeat until Received or (not WaitCarrier) or T.TimeOut or CurAbortFunc;
 T.Done;
 if (not Carrier) or T.TimeOut then WaitReceived:=False else
 WaitReceived:=True;
end;

end.
